#ifndef EFL_GENERATED_EVAS_3D_MATERIAL_HH
#define EFL_GENERATED_EVAS_3D_MATERIAL_HH

extern "C"
{
#include <Efl.h>
}
#include <Eo.hh>

#include <eo_cxx_interop.hh>

extern "C"
{
#include "evas_3d_material.eo.h"
}

#include "evas_3d_object.eo.hh"
#include "evas_common_interface.eo.hh"

struct evas_3d_material;

namespace eo_cxx {

struct evas_3d_material
{
   /// @param attrib Material attribute ID.
   /// @param r Red component of the color.
   /// @param g Green component of the color.
   /// @param b Blue component of the color.
   /// @param a Alpha component of the color.
   ///
   void color_set(Evas_3D_Material_Attrib attrib_, Evas_Real r_, Evas_Real g_, Evas_Real b_, Evas_Real a_) const;


   /// @param attrib Material attribute ID.
   /// @param[out] r Pointer to receive red component of the color.
   /// @param[out] g Pointer to receive green component of the color.
   /// @param[out] b Pointer to receive blue component of the color.
   /// @param[out] a Pointer to receive alpha component of the color.
   ///
   void color_get(Evas_3D_Material_Attrib attrib_, Evas_Real* r_, Evas_Real* g_, Evas_Real* b_, Evas_Real* a_) const;


   /// @param enable Whether to enable the attribute (@c EINA_TRUE), or not (@c EINA_FALSE).
   ///
   bool enable_get(Evas_3D_Material_Attrib attrib_) const;


   /// @param enable Whether to enable the attribute (@c EINA_TRUE), or not (@c EINA_FALSE).
   ///
   void enable_set(Evas_3D_Material_Attrib attrib_, bool enable_) const;


   /// @param shininess Shininess value.
   ///
   Evas_Real shininess_get() const;


   /// @param shininess Shininess value.
   ///
   void shininess_set(Evas_Real shininess_) const;


   /// @param texture 
   ///
   Evas_3D_Texture * texture_get(Evas_3D_Material_Attrib attrib_) const;


   /// @brief Set the texture of the given material.
   ///
   /// You have to enable the desired attribute first.
   ///
   /// @see evas_3d_material_enable_set()
   ///
   /// @ingroup Evas_3D_Material
   ///
   /// @param texture 
   ///
   void texture_set(Evas_3D_Material_Attrib attrib_, Evas_3D_Texture * texture_) const;



   static Eo_Class const* _eo_class()
   {
      return(EVAS_3D_MATERIAL_CLASS);
   }

   operator ::evas_3d_material() const;
   operator ::evas_3d_material&();
   operator ::evas_3d_material const&() const;

   template <typename D>
   struct address_of
   {
      operator ::evas_3d_material*() const { return static_cast<::evas_3d_material*>(static_cast<D const*>(this)->p); }
      operator ::evas_3d_material const*() const { return static_cast<::evas_3d_material const*>(static_cast<D const*>(this)->p); }
   };

   template <typename D>
   struct address_const_of
   {
      operator ::evas_3d_material const*() const { return static_cast<::evas_3d_material const*>(static_cast<D const*>(this)->p); }
   };

private:
   Eo* _concrete_eo_ptr() const
   {
      return static_cast<::efl::eo::concrete const*>(static_cast<void const*>(this))->_eo_ptr();
   }

};

}

struct evas_3d_material
      : ::efl::eo::concrete
      , ::eo_cxx::eo::base
      , ::eo_cxx::evas::common_interface
      , ::eo_cxx::evas_3d_object
{
   evas_3d_material(::efl::eo::parent_type _p = (::efl::eo::parent = nullptr))
      : evas_3d_material(_ctors_call(_p))
   {}

   /// @brief Eo Constructor.
   ///
   /// Constructs the object from an Eo* pointer stealing its ownership.
   ///
   /// @param eo The Eo object pointer.
   ///
   explicit evas_3d_material(Eo* eo)
      : ::efl::eo::concrete(eo)
   {}

   /// @brief nullptr_t Constructor.
   ///
   /// Constructs an empty (null) object.
   ///
   explicit evas_3d_material(std::nullptr_t)
      : ::efl::eo::concrete(nullptr)
   {}

   /// @brief Copy Constructor.
   ///
   evas_3d_material(evas_3d_material const& other)
      : evas_3d_material(eo_ref(other._eo_ptr()))
   {}

   ~evas_3d_material() {}

   /// @param attrib Material attribute ID.
   /// @param r Red component of the color.
   /// @param g Green component of the color.
   /// @param b Blue component of the color.
   /// @param a Alpha component of the color.
   ///
   void color_set(Evas_3D_Material_Attrib attrib_, Evas_Real r_, Evas_Real g_, Evas_Real b_, Evas_Real a_) const;


   /// @param attrib Material attribute ID.
   /// @param[out] r Pointer to receive red component of the color.
   /// @param[out] g Pointer to receive green component of the color.
   /// @param[out] b Pointer to receive blue component of the color.
   /// @param[out] a Pointer to receive alpha component of the color.
   ///
   void color_get(Evas_3D_Material_Attrib attrib_, Evas_Real* r_, Evas_Real* g_, Evas_Real* b_, Evas_Real* a_) const;


   /// @param enable Whether to enable the attribute (@c EINA_TRUE), or not (@c EINA_FALSE).
   ///
   bool enable_get(Evas_3D_Material_Attrib attrib_) const;


   /// @param enable Whether to enable the attribute (@c EINA_TRUE), or not (@c EINA_FALSE).
   ///
   void enable_set(Evas_3D_Material_Attrib attrib_, bool enable_) const;


   /// @param shininess Shininess value.
   ///
   Evas_Real shininess_get() const;


   /// @param shininess Shininess value.
   ///
   void shininess_set(Evas_Real shininess_) const;


   /// @param texture 
   ///
   Evas_3D_Texture * texture_get(Evas_3D_Material_Attrib attrib_) const;


   /// @brief Set the texture of the given material.
   ///
   /// You have to enable the desired attribute first.
   ///
   /// @see evas_3d_material_enable_set()
   ///
   /// @ingroup Evas_3D_Material
   ///
   /// @param texture 
   ///
   void texture_set(Evas_3D_Material_Attrib attrib_, Evas_3D_Texture * texture_) const;



   static Eo_Class const* _eo_class()
   {
      return(EVAS_3D_MATERIAL_CLASS);
   }

   struct address_of
      : ::eo_cxx::evas_3d_material::address_of<address_of>
      , ::eo_cxx::eo::base::address_of<address_of>
      , ::eo_cxx::evas::common_interface::address_of<address_of>
      , ::eo_cxx::evas_3d_object::address_of<address_of>
      , ::efl::eo::detail::concrete_address_of
   {
      explicit address_of(::evas_3d_material* p)
         : ::efl::eo::detail::concrete_address_of(p)
      {}
   };
   address_of operator&() { return address_of(this); }

   struct address_const_of
      : ::eo_cxx::evas_3d_material::address_const_of<address_const_of>
      , ::eo_cxx::eo::base::address_const_of<address_const_of>
      , ::eo_cxx::evas::common_interface::address_const_of<address_const_of>
      , ::eo_cxx::evas_3d_object::address_const_of<address_const_of>
      , ::efl::eo::detail::concrete_address_const_of
   {
      explicit address_const_of(::evas_3d_material const* p)
         : ::efl::eo::detail::concrete_address_const_of(p)
      {}
   };
   address_const_of operator&() const { return address_const_of(this); }

private:
   static Eo* _ctors_call(::efl::eo::parent_type _p)
   {
      Eo* _ret_eo = eo_add_ref(EVAS_3D_MATERIAL_CLASS, _p._eo_raw, );

      return _ret_eo;
   }

      Eo* _concrete_eo_ptr() const { return _eo_ptr(); }
};

static_assert(sizeof(::evas_3d_material) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<::evas_3d_material>::value, "");

inline void evas_3d_material::color_set(Evas_3D_Material_Attrib attrib_, Evas_Real r_, Evas_Real g_, Evas_Real b_, Evas_Real a_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_material_color_set(attrib_, r_, g_, b_, a_));
}


inline void evas_3d_material::color_get(Evas_3D_Material_Attrib attrib_, Evas_Real* r_, Evas_Real* g_, Evas_Real* b_, Evas_Real* a_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_material_color_get(attrib_, r_, g_, b_, a_));
}


inline bool evas_3d_material::enable_get(Evas_3D_Material_Attrib attrib_) const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_3d_material_enable_get(attrib_));
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}


inline void evas_3d_material::enable_set(Evas_3D_Material_Attrib attrib_, bool enable_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_material_enable_set(attrib_, ::efl::eolian::to_c(enable_)));
}


inline Evas_Real evas_3d_material::shininess_get() const
{
   Evas_Real _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_3d_material_shininess_get());
   return _tmp_ret;
}


inline void evas_3d_material::shininess_set(Evas_Real shininess_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_material_shininess_set(shininess_));
}


inline Evas_3D_Texture * evas_3d_material::texture_get(Evas_3D_Material_Attrib attrib_) const
{
   Evas_3D_Texture * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_3d_material_texture_get(attrib_));
   return _tmp_ret;
}


inline void evas_3d_material::texture_set(Evas_3D_Material_Attrib attrib_, Evas_3D_Texture * texture_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_material_texture_set(attrib_, texture_));
}


inline void eo_cxx::evas_3d_material::color_set(Evas_3D_Material_Attrib attrib_, Evas_Real r_, Evas_Real g_, Evas_Real b_, Evas_Real a_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_material_color_set(attrib_, r_, g_, b_, a_));
}


inline void eo_cxx::evas_3d_material::color_get(Evas_3D_Material_Attrib attrib_, Evas_Real* r_, Evas_Real* g_, Evas_Real* b_, Evas_Real* a_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_material_color_get(attrib_, r_, g_, b_, a_));
}


inline bool eo_cxx::evas_3d_material::enable_get(Evas_3D_Material_Attrib attrib_) const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_3d_material_enable_get(attrib_));
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}


inline void eo_cxx::evas_3d_material::enable_set(Evas_3D_Material_Attrib attrib_, bool enable_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_material_enable_set(attrib_, ::efl::eolian::to_c(enable_)));
}


inline Evas_Real eo_cxx::evas_3d_material::shininess_get() const
{
   Evas_Real _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_3d_material_shininess_get());
   return _tmp_ret;
}


inline void eo_cxx::evas_3d_material::shininess_set(Evas_Real shininess_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_material_shininess_set(shininess_));
}


inline Evas_3D_Texture * eo_cxx::evas_3d_material::texture_get(Evas_3D_Material_Attrib attrib_) const
{
   Evas_3D_Texture * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_3d_material_texture_get(attrib_));
   return _tmp_ret;
}


inline void eo_cxx::evas_3d_material::texture_set(Evas_3D_Material_Attrib attrib_, Evas_3D_Texture * texture_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_material_texture_set(attrib_, texture_));
}


inline ::eo_cxx::evas_3d_material::operator ::evas_3d_material() const
{
   return *static_cast<::evas_3d_material const*>(static_cast<void const*>(this));
}

inline ::eo_cxx::evas_3d_material::operator ::evas_3d_material&()
{
   return *static_cast<::evas_3d_material*>(static_cast<void*>(this));
}

inline ::eo_cxx::evas_3d_material::operator ::evas_3d_material const&() const
{
   return *static_cast<::evas_3d_material const*>(static_cast<void const*>(this));
}

template <typename T>
void _evas_3d_material_color_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Evas_3D_Material_Attrib attrib_, Evas_Real r_, Evas_Real g_, Evas_Real b_, Evas_Real a_)
{
   try
      {
         static_cast<T*>(self->this_)->color_set(attrib_, r_, g_, b_, a_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void _evas_3d_material_color_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Evas_3D_Material_Attrib attrib_, Evas_Real* r_, Evas_Real* g_, Evas_Real* b_, Evas_Real* a_)
{
   try
      {
         static_cast<T*>(self->this_)->color_get(attrib_, r_, g_, b_, a_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
bool _evas_3d_material_enable_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Evas_3D_Material_Attrib attrib_)
{
   bool _tmp_ret{};
   try
      {
         _tmp_ret = static_cast<T*>(self->this_)->enable_get(attrib_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
   return _tmp_ret;
}

template <typename T>
void _evas_3d_material_enable_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Evas_3D_Material_Attrib attrib_, Eina_Bool enable_)
{
   try
      {
         static_cast<T*>(self->this_)->enable_set(attrib_, ::efl::eolian::to_cxx<bool>(enable_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
Evas_Real _evas_3d_material_shininess_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   Evas_Real _tmp_ret{};
   try
      {
         _tmp_ret = static_cast<T*>(self->this_)->shininess_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
   return _tmp_ret;
}

template <typename T>
void _evas_3d_material_shininess_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Evas_Real shininess_)
{
   try
      {
         static_cast<T*>(self->this_)->shininess_set(shininess_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
Evas_3D_Texture * _evas_3d_material_texture_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Evas_3D_Material_Attrib attrib_)
{
   Evas_3D_Texture * _tmp_ret{};
   try
      {
         _tmp_ret = static_cast<T*>(self->this_)->texture_get(attrib_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
   return _tmp_ret;
}

template <typename T>
void _evas_3d_material_texture_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Evas_3D_Material_Attrib attrib_, Evas_3D_Texture * texture_)
{
   try
      {
         static_cast<T*>(self->this_)->texture_set(attrib_, texture_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::evas_3d_material >
{
   template <typename T>
   struct type
         : virtual operations< ::evas_3d_object >::template type<T>
         , virtual operations< ::evas::common_interface >::template type<T>
   {
      virtual void color_set(Evas_3D_Material_Attrib attrib_, Evas_Real r_, Evas_Real g_, Evas_Real b_, Evas_Real a_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::evas_3d_material_color_set(attrib_, r_, g_, b_, a_));
      }

      virtual void color_get(Evas_3D_Material_Attrib attrib_, Evas_Real* r_, Evas_Real* g_, Evas_Real* b_, Evas_Real* a_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::evas_3d_material_color_get(attrib_, r_, g_, b_, a_));
      }

      virtual bool enable_get(Evas_3D_Material_Attrib attrib_)
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::evas_3d_material_enable_get(attrib_));
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void enable_set(Evas_3D_Material_Attrib attrib_, bool enable_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::evas_3d_material_enable_set(attrib_, ::efl::eolian::to_c(enable_)));
      }

      virtual Evas_Real shininess_get()
      {
         Evas_Real _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::evas_3d_material_shininess_get());
            return _tmp_ret;
      }

      virtual void shininess_set(Evas_Real shininess_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::evas_3d_material_shininess_set(shininess_));
      }

      virtual Evas_3D_Texture * texture_get(Evas_3D_Material_Attrib attrib_)
      {
         Evas_3D_Texture * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::evas_3d_material_texture_get(attrib_));
            return _tmp_ret;
      }

      virtual void texture_set(Evas_3D_Material_Attrib attrib_, Evas_3D_Texture * texture_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::evas_3d_material_texture_set(attrib_, texture_));
      }

   };
};


template<>
struct operation_description_class_size< ::evas_3d_material >
{
   static const int value = 8 + operation_description_class_size<::evas_3d_object >::value + operation_description_class_size<::evas::common_interface >::value;
};

template <typename T>
int initialize_operation_description(::efl::eo::detail::tag<::evas_3d_material>
                                 , Eo_Op_Description* ops)
{
   (void)ops;
   ops[0].func = reinterpret_cast<void*>(& ::_evas_3d_material_color_set_wrapper<T>);
   ops[0].api_func = reinterpret_cast<void*>(& ::evas_3d_material_color_set);
   ops[0].op = EO_OP_OVERRIDE;
   ops[0].op_type = EO_OP_TYPE_REGULAR;
   ops[0].doc = NULL;

   ops[1].func = reinterpret_cast<void*>(& ::_evas_3d_material_color_get_wrapper<T>);
   ops[1].api_func = reinterpret_cast<void*>(& ::evas_3d_material_color_get);
   ops[1].op = EO_OP_OVERRIDE;
   ops[1].op_type = EO_OP_TYPE_REGULAR;
   ops[1].doc = NULL;

   ops[2].func = reinterpret_cast<void*>(& ::_evas_3d_material_enable_get_wrapper<T>);
   ops[2].api_func = reinterpret_cast<void*>(& ::evas_3d_material_enable_get);
   ops[2].op = EO_OP_OVERRIDE;
   ops[2].op_type = EO_OP_TYPE_REGULAR;
   ops[2].doc = NULL;

   ops[3].func = reinterpret_cast<void*>(& ::_evas_3d_material_enable_set_wrapper<T>);
   ops[3].api_func = reinterpret_cast<void*>(& ::evas_3d_material_enable_set);
   ops[3].op = EO_OP_OVERRIDE;
   ops[3].op_type = EO_OP_TYPE_REGULAR;
   ops[3].doc = NULL;

   ops[4].func = reinterpret_cast<void*>(& ::_evas_3d_material_shininess_get_wrapper<T>);
   ops[4].api_func = reinterpret_cast<void*>(& ::evas_3d_material_shininess_get);
   ops[4].op = EO_OP_OVERRIDE;
   ops[4].op_type = EO_OP_TYPE_REGULAR;
   ops[4].doc = NULL;

   ops[5].func = reinterpret_cast<void*>(& ::_evas_3d_material_shininess_set_wrapper<T>);
   ops[5].api_func = reinterpret_cast<void*>(& ::evas_3d_material_shininess_set);
   ops[5].op = EO_OP_OVERRIDE;
   ops[5].op_type = EO_OP_TYPE_REGULAR;
   ops[5].doc = NULL;

   ops[6].func = reinterpret_cast<void*>(& ::_evas_3d_material_texture_get_wrapper<T>);
   ops[6].api_func = reinterpret_cast<void*>(& ::evas_3d_material_texture_get);
   ops[6].op = EO_OP_OVERRIDE;
   ops[6].op_type = EO_OP_TYPE_REGULAR;
   ops[6].doc = NULL;

   ops[7].func = reinterpret_cast<void*>(& ::_evas_3d_material_texture_set_wrapper<T>);
   ops[7].api_func = reinterpret_cast<void*>(& ::evas_3d_material_texture_set);
   ops[7].op = EO_OP_OVERRIDE;
   ops[7].op_type = EO_OP_TYPE_REGULAR;
   ops[7].doc = NULL;

   initialize_operation_description<T>(::efl::eo::detail::tag<::evas_3d_object>(), &ops[8]);
   initialize_operation_description<T>(::efl::eo::detail::tag<::evas::common_interface>(), &ops[8 + operation_description_class_size<::evas_3d_object>::value]);
   return 0;
}
inline void
call_constructor(::efl::eo::detail::tag< ::evas_3d_material >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               ::efl::eo::detail::args_class<::evas_3d_material, ::std::tuple<::efl::eo::parent_type> > const& args)
{
   eo_do(eo, ::eo_parent_set(args.get<0>()._eo_raw));
}

inline Eo_Class const* get_eo_class(tag<::evas_3d_material>)
{
   return (EVAS_3D_MATERIAL_CLASS);
}

} } }
#endif // EFL_GENERATED_EVAS_3D_MATERIAL_HH

